#include "tjscli.h"
#include <stdio.h>

/**
 * gp@\܂B
 */
static void TJSCLIDisplayUsage()
{
	wprintf(TJSCLI_USAGE_STR_WC);
}


/**
 * Gg|CgłB
 */
int main(int argc, char* argv[])
{
	setlocale(LC_ALL, ""); // [Jݒ
	const wchar_t * errmsg = NULL;

	// load DLL
	if (!TJSELoadLibrary(errmsg)) {
		printf("%ls\n", errmsg);
		abort();
	}

	// version check
	if (!TJSECheckDLLAcceptance(0, 0, 0, 0, 0, TJSE_DLL_VERSION_ANY, errmsg)) {
		printf("%ls\n", errmsg);
		abort();
	}

	// ߂̈t@CƌȂ
	if (argc > 1) {
		wchar_t * content;
		int content_len;

		if (TJSELoadScriptFileSTDC(argv[1], content, content_len, errmsg)) {
			TJSEExecSimpleScriptSTDC(content, errmsg);
			delete[] content;
		} else {
			printf("%ls", errmsg);
		}

	// Ȃ
	} else {
		TJSCLIDisplayUsage();
	}

	// free DLL
	if (!TJSEFreeLibrary()) {
		printf("łȂYO!\n");
		abort();
	}

	return 0;
}
